# IPC Scheduling and Shared Memory in C

Jacob Barger 

//Program should be run on linux/unix console containing gcc library// 

This program is intended to take an input file consisting of an amount
to increment and times for child processes to launch and then terminate at.

The program also takes in amount of processes to run <-n> and the amount
that can run in the system at once <-s>. Input and output files are specified
via <-i> and <-o> respectively.
The input file must have enough lines of time specification to match the amount
processes you intend to run <n>
The default running environment: -i input.txt -o output.txt -n 4 -s 2
For this to work you must have an input.txt already created.
An example of successful program CL input would be:
            ./oss -i inputFile -o outputFile -n 4 -s 2

The input file is structured as:
<amount to increment by>
<second start time> <nanosecond start time> <duration before terminating>

How to run the make file:
make -f makeFile

Ensure input file has been created <input.txt> and it has atleast four 
lines of times, assuming you want the default running environment 


How to launch the application:
./oss

Clean up executables:
make -f makeFile clean


Problems encountered:

Sometimes children would hold onto shared memory, and Id have to manually delete
the segment 
Solution: add termination of children criteria to while loop

Large gap in times of child launch and actual time received
Now operating under the assumption thats just how fast processor works

